#pragma once

#ifndef p_reflect_refract_h
#define p_reflect_refract_h

#ifdef HPUX
#pragma OPT_LEVEL 1	/* workaround for HP/UX optimizer bug, +O2 and +O3 */
#endif

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>		/* for abs */
#include <float.h>		/* for FLT_MAX */
#include <math.h>
#include <string.h>
#include <assert.h>
#include "shader.h"
#include "p_static_param.h"
#include "p_utils.h"


#ifdef DEBUG
#define miASSERT assert
#else
#define miASSERT(x)
#endif

miCBoolean locate_volume(miState *state, miScalar &ior_in, miScalar &ior_out, miBoolean ignore_normals);
miBoolean p_reflect(miColor *result, miState *state, p_MegaTK_t *paras, miColor *glossy, miScalar *shiny,
                    miBoolean anisotropic, miScalar *shiny_u, miScalar *shiny_v,
                    miScalar falloff_start, miScalar falloff_stop, miBoolean falloff_to_color, miColor *falloff_color, int samples, int samples_decrease);
miBoolean p_refract(miColor *result, miState *state, p_MegaTK_t *paras, miColor *glossy, miScalar *shiny,
                    miBoolean anisotropic, miScalar *shiny_u, miScalar *shiny_v,
                    miColor *absorb_in, miColor *absorb_out, 
					miScalar falloff_start, miScalar falloff_stop, miBoolean falloff_to_color, miColor *falloff_color, 
					int samples, miCBoolean enter_surf, int samples_decrease);
miBoolean p_path_diffuse(miColor *result, miState *state, int max_depth, int samples, int samples_decrease);

#endif  // p_reflect_refract_h
