#pragma once
#ifndef p_static_param_h
#define p_static_param_h

#include "shader.h"

typedef struct
{
	miColor		cSurface;
	miColor		cOpacity;
		int opacity_conversion;
	miBoolean	use_constant;
		miScalar	cConst;
		miColor		c_color;
	miBoolean	use_simple_diffuse;
		miScalar	cds;
		miScalar	sd_roughness;
		miTag		sd_light_category;
	miBoolean	use_fur_diffuse;
		miScalar	cdf;
		miScalar	f_d_angle;
		miColor 	f_skinColor;
		miScalar 	f_hairDensity;
		miScalar 	f_backwardScatering;
		miScalar 	f_forwardScattering;
		miScalar 	f_hairOverHairShadow;
		miScalar 	f_shadowAttenuation;
		miScalar 	f_startShadowCos;
		miScalar 	f_endShadowCos;
		miScalar 	f_hairLength;
		miScalar 	f_hairBaseRadius;
		miScalar 	f_hairTipRadius;
		miTag		fd_light_category;
	miBoolean	use_phong_specular;
		miScalar	p_cS;
		miColor		p_specular;
		miScalar	p_exponent;
		miTag		p_light_category;
	miBoolean	use_blinn_specular;
		miScalar	b_cS;
		miColor		b_specular;
		miScalar	b_eccentricity;
		miScalar	b_specularRollOff;
		miTag		b_light_category;
	miBoolean	use_velvet_specular;
		miScalar	v_cS;
		miColor		v_sheen_color;
		miScalar	v_backscatter;
		miScalar	v_edginess;
		miScalar	v_roughness;
		miTag		v_light_category;
	miBoolean	use_wet_specular;
		miScalar	we_cS;
		miColor		we_specular;
		miScalar	we_roughness;
		miScalar	we_sharpness;
		miTag		we_light_category;
	miBoolean	use_ward_specular;
		miScalar	w_cS;
		miColor		w_specular;
		miScalar	w_shiny_u;		
		miScalar	w_shiny_v;
		miBoolean	w_use_deriv;
		miVector	w_u;
		miVector	w_v;
		miTag		w_light_category;
	miBoolean	use_fur_specular;
		miScalar	f_cS;
		miScalar	f_s_angle;
		miColor 	f_specular1Color;
		miScalar 	f_specular1Exponent;
		miColor 	f_specular2Color;
		miScalar 	f_specular2Exponent;
		miScalar 	f_tangentBreakupAmt;
		miScalar 	f_tangentBreakup;
		miTag		f_light_category;
	miBoolean	use_indirect_illum;
		miColor		cInd;
		miScalar	saturation_indirect;
		miBoolean	path_indirect;
		int			path_indirect_samples;
		int			path_indirect_depth;
		miBoolean	ind_ignore_bump;
	miBoolean	use_ambient;
		miScalar	cAmb;
		miColor		ambient_color;
	miBoolean	use_occlusion;
		miColor		o_base_color;
		miColor		o_dirt_color;
		miScalar	o_spread;
		miInteger   o_samples;
		miScalar	o_near_clip;
		miScalar	o_far_clip;
		miScalar	o_falloff_gain;
		miScalar	o_gamma;
		miVector	o_basis;
		miScalar	o_basis_blend;
		int			o_opacity_mode;
		miBoolean	o_bent_normal;
		miInteger	o_bent_space;
		miBoolean	o_trace_environment;
		miBoolean	o_inv_sec_illum;
		miBoolean	o_inv_refl;
		miBoolean	o_inv_refr;
		miScalar	effect_diffuse;
		miScalar	effect_specular;
		miScalar	effect_indirect;
		miScalar	effect_ambient;
		miColor		custom_occlusion;
	miBoolean	use_reflection;
		miScalar	cReflect;
		miColor		glossy_refl;
		miScalar	shiny_refl;
		miBoolean	anisotropic_reflect;
		miScalar	shiny_refl_u;
		miScalar	shiny_refl_v;
		int			samples_refl;
		miScalar	fresnel_refl;
		miScalar	falloff_start_refl;
		miScalar	falloff_stop_refl;
		miBoolean	falloff_to_color_refl;
		miColor		falloff_color_refl;
//		miScalar	rainbowness_refl;
//		int			i_spectrum_refl;
//		int			n_spectrum_refl;
//		miColor		spectrum_refl[1];
		miScalar	diff_minus_reflect;
		miColor		custom_reflect;
	miBoolean	use_refraction;
		miScalar	cRefract;
		miColor		glossy_refr;
		miScalar	shiny_refr;
		miBoolean	anisotropic_refract;
		miScalar	shiny_refr_u;
		miScalar	shiny_refr_v;
		int			samples_refr;
		miScalar	ior_in_refr;
		miColor		refr_absorb_in;
		miScalar	ior_out_refr;
		miColor		refr_absorb_out;
		miScalar	fresnel_refr;
		miScalar	falloff_start_refr;
		miScalar	falloff_stop_refr;
		miBoolean	falloff_to_color_refr;
		miColor		falloff_color_refr;
//		miScalar	rainbowness_refr;
//		int			i_spectrum_refr;
//		int			n_spectrum_refr;
//		miColor		spectrum_refr[1];
		miScalar	diff_minus_refract;
		miColor		custom_refract;
	miBoolean		russian_roulette;
	int				russian_roulette_level;
	int				samples_decrease_factor;
	miBoolean		ignore_normals;
	int				reflection_depth;
	int				refraction_depth;
	miBoolean	use_incandescence;
		miScalar	cInc;
		miColor		incandescence;
		miBoolean	use_SpecialC1;
		miColor		specialC1;
		miBoolean	use_SpecialC2;
		miColor		specialC2;
		miBoolean	use_SpecialC3;
		miColor		specialC3;
		miBoolean	use_SpecialC4;
		miColor		specialC4;
		miBoolean	use_SpecialC5;
		miColor		specialC5;
		miBoolean	use_SpecialC6;
		miColor		specialC6;
		miBoolean	use_SpecialC7;
		miColor		specialC7;
		miBoolean	use_SpecialC8;
		miColor		specialC8;
		miBoolean	use_SpecialC9;
		miColor		specialC9;
		miBoolean	use_SpecialC10;
		miColor		specialC10;
	miBoolean	use_normal;
		miBoolean	add_to_normal;
		miVector	input_normal;
	miBoolean		use_z;
		miScalar 	near;
		miScalar 	far;
		miBoolean 	opacity_z;
		miBoolean	reflection_z;
		miBoolean	refraction_z;
		miBoolean 	use_float_z;
		miBoolean 	invert_z;

	miBoolean shading_pass;
	miBoolean color_occlusion_pass;
	miBoolean diffuse_pass;
	miBoolean diffuse_shadow_pass;
	miBoolean specular_pass;
	miBoolean specular_shadow_pass;
	miBoolean occlusion_pass;
	miBoolean indirect_illum_pass;
	miBoolean ambient_pass;
	miBoolean amb_occlusion_pass;
	miBoolean reflect_pass;
	miBoolean refract_pass;
	miBoolean incandescence_pass;
	miBoolean z_pass;
	miBoolean bent_normal_pass;
	miBoolean specialC1_pass;
	miBoolean specialC2_pass;
	miBoolean specialC3_pass;
	miBoolean specialC4_pass;
	miBoolean specialC5_pass;
	miBoolean specialC6_pass;
	miBoolean specialC7_pass;
	miBoolean specialC8_pass;
	miBoolean specialC9_pass;
	miBoolean specialC10_pass;

	int			mode;
	int			i_light;
	int			n_light;
	miTag		light[1];
}p_MegaTK_t;

struct static_param
{
	int opacity_conversion;
	miBoolean	use_constant;
	miBoolean	use_simple_diffuse;
	const char *sd_light_category;
	miBoolean	use_fur_diffuse;
	const char *fd_light_category;
	miBoolean	use_phong_specular;
	const char *p_light_category;
	miBoolean	use_blinn_specular;
	const char *b_light_category;
	miBoolean	use_velvet_specular;
	const char *v_light_category;
	miBoolean	use_wet_specular;
	const char *we_light_category;
	miBoolean	use_ward_specular;
	const char *w_light_category;
	miBoolean	w_use_deriv;
	miBoolean	use_fur_specular;
	const char *f_light_category;
	miBoolean	use_indirect_illum;
	miBoolean	path_indirect;
	int			path_indirect_samples;
	int			path_indirect_depth;
	miBoolean	ind_ignore_bump;
	miBoolean	use_ambient;
	miBoolean	use_occlusion;
	miBoolean	o_trace_environment;
	miBoolean	o_inv_sec_illum;
	miBoolean	o_inv_refl;
	miBoolean	o_inv_refr;
	miScalar	o_spread;
	int			o_samples;
	miScalar	o_near_clip;
	miScalar	o_far_clip;
	miScalar	o_falloff_gain;
	miScalar	o_gamma;
	int			o_opacity_mode;
	miBoolean	o_bent_normal;
	miInteger	o_bent_space;
	miBoolean	use_reflection;
	miBoolean	anisotropic_reflect;
	miBoolean	use_refraction;
	miBoolean	anisotropic_refract;
	miBoolean   russian_roulette;
	int			samples_decrease;
	miBoolean	use_incandescence;

	miBoolean	use_SpecialC1;	
	miBoolean	use_SpecialC2;
	miBoolean	use_SpecialC3;
	miBoolean	use_SpecialC4;
	miBoolean	use_SpecialC5;
	miBoolean	use_SpecialC6;
	miBoolean	use_SpecialC7;	
	miBoolean	use_SpecialC8;
	miBoolean	use_SpecialC9;
	miBoolean	use_SpecialC10;

	miBoolean	use_z;
	miBoolean	opacity_z;
	miBoolean	reflection_z;
	miBoolean	refraction_z;
	miBoolean 	use_float_z;
	miBoolean 	invert_z;
//	miBoolean	use_special;
	miBoolean	use_normal;
	miBoolean	add_normal;

	miScalar	ior;		/* index of refraction */
	miScalar	ior_out;	/* outside ior for interface */
	miCBoolean	ignore_normals;	/* ignore normals? */
	miCBoolean	is_interface;	/* simulate interface */
	int			russian_level;

	miBoolean shading_pass;
	int shading_buf;
	miBoolean color_pass;
	int color_buf;
	miBoolean diffuse_pass;
	int diffuse_buf;
	miBoolean diffuse_shadow_pass;
	int diffuse_shadow_buf;
	miBoolean specular_pass;
	int specular_buf;
	miBoolean specular_shadow_pass;
	int specular_shadow_buf;
	miBoolean occlusion_pass;
	int occlusion_buf;
	miBoolean indirect_illum_pass;
	int indirect_illum_buf;
	miBoolean ambient_pass;
	int ambient_buf;
	miBoolean amb_occlusion_pass;
	int amb_occlusion_buf;
	miBoolean reflect_pass;
	int reflect_buf;
	miBoolean refract_pass;
	int refract_buf;
	miBoolean incandescence_pass;
	int incandescence_buf;
	miBoolean z_pass;
	int z_buf;
	miBoolean bent_normal_pass;
	int bent_normal_buf;
	miBoolean specialC1_pass;
	int specialC1_buf;
	miBoolean specialC2_pass;
	int specialC2_buf;
	miBoolean specialC3_pass;
	int specialC3_buf;
	miBoolean specialC4_pass;
	int specialC4_buf;
	miBoolean specialC5_pass;
	int specialC5_buf;
	miBoolean specialC6_pass;
	int specialC6_buf;
	miBoolean specialC7_pass;
	int specialC7_buf;
	miBoolean specialC8_pass;
	int specialC8_buf;
	miBoolean specialC9_pass;
	int specialC9_buf;
	miBoolean specialC10_pass;
	int specialC10_buf;
};

struct static_param_dof
{
	miBoolean shading_pass;
	int shading_buf;
	miBoolean color_pass;
	int color_buf;
	miBoolean diffuse_pass;
	int diffuse_buf;
	miBoolean diffuse_shadow_pass;
	int diffuse_shadow_buf;
	miBoolean specular_pass;
	int specular_buf;
	miBoolean specular_shadow_pass;
	int specular_shadow_buf;
	miBoolean occlusion_pass;
	int occlusion_buf;
	miBoolean indirect_illum_pass;
	int indirect_illum_buf;
	miBoolean ambient_pass;
	int ambient_buf;
	miBoolean amb_occlusion_pass;
	int amb_occlusion_buf;
	miBoolean reflect_pass;
	int reflect_buf;
	miBoolean refract_pass;
	int refract_buf;
	miBoolean incandescence_pass;
	int incandescence_buf;
	miBoolean z_pass;
	int z_buf;
	miBoolean bent_normal_pass;
	int bent_normal_buf;
	miBoolean specialC1_pass;
	int specialC1_buf;
	miBoolean specialC2_pass;
	int specialC2_buf;
	miBoolean specialC3_pass;
	int specialC3_buf;
	miBoolean specialC4_pass;
	int specialC4_buf;
	miBoolean specialC5_pass;
	int specialC5_buf;
	miBoolean specialC6_pass;
	int specialC6_buf;
	miBoolean specialC7_pass;
	int specialC7_buf;
	miBoolean specialC8_pass;
	int specialC8_buf;
	miBoolean specialC9_pass;
	int specialC9_buf;
	miBoolean specialC10_pass;
	int specialC10_buf;
};

#endif  // p_static_param_h
